<!--
 ~ Copyright (c) 2005-2010, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 ~
 ~ WSO2 Inc. licenses this file to you under the Apache License,
 ~ Version 2.0 (the "License"); you may not use this file except
 ~ in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~    http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing,
 ~ software distributed under the License is distributed on an
 ~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 ~ KIND, either express or implied.  See the License for the
 ~ specific language governing permissions and limitations
 ~ under the License.
 -->
<%@ page import="org.apache.axiom.om.xpath.AXIOMXPath" %>
<%@ page import="org.jaxen.BaseXPath" %>
<%@ page import="org.wso2.carbon.mediator.rule.RuleMediator" %>
<%@ page import="org.wso2.carbon.mediator.rule.ui.internal.RuleMediatorClientHelper" %>
<%@ page import="org.wso2.carbon.mediator.service.ui.Mediator" %>
<%@ page import="org.wso2.carbon.rulecep.commons.descriptions.PropertyDescription" %>
<%@ page import="org.wso2.carbon.rulecep.commons.descriptions.ResourceDescription" %>
<%@ page import="org.wso2.carbon.rulecep.commons.descriptions.rule.RuleSetDescription" %>
<%@ page import="org.wso2.carbon.rulecep.commons.descriptions.rule.SessionDescription" %>
<%@ page import="org.wso2.carbon.rulecep.commons.descriptions.rule.mediator.RuleMediatorDescription" %>
<%@ page import="org.wso2.carbon.sequences.ui.util.SequenceEditorHelper" %>
<%@ page import="org.wso2.carbon.sequences.ui.util.ns.NameSpacesRegistrar" %>
<%@ page import="java.util.Collection" %>
<%@ page import="java.util.HashMap" %>
<%@ page import="java.util.List" %>
<%@ page import="java.util.Map" %>
<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1" %>
<%--
  ~  Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  Licensed under the Apache License, Version 2.0 (the "License");
  ~  you may not use this file except in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~        http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing, software
  ~  distributed under the License is distributed on an "AS IS" BASIS,
  ~  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~  See the License for the specific language governing permissions and
  ~  limitations under the License.
  --%>

<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<jsp:include page="../resources/resources-i18n-ajaxprocessor.jsp"/>

<fmt:bundle basename="org.wso2.carbon.mediator.rule.ui.i18n.Resources">
<carbon:jsi18n
        resourceBundle="org.wso2.carbon.mediator.rule.ui.i18n.JSResources"
        request="<%=request%>" i18nObjectName="rulejsi18n"/>

<%
    Mediator mediator = SequenceEditorHelper.getEditingMediator(request, session);
    if (!(mediator instanceof RuleMediator)) {
        // todo : proper error handling
        throw new RuntimeException("Unable to edit the mediator");
    }

    RuleMediator ruleMediator = (RuleMediator) mediator;
    RuleMediatorDescription configuration = ruleMediator.getRuleMediatorDescription();
    if (configuration == null) {
        configuration = new RuleMediatorDescription();
    }
    NameSpacesRegistrar nameSpacesRegistrar = NameSpacesRegistrar.getInstance();
    //Execution Set Metadata
    RuleSetDescription setDescription = configuration.getRuleSetDescription();
    if (setDescription == null) {
        setDescription = new RuleSetDescription();
    }
    String key = setDescription.getKey() != null ?
            setDescription.getKey() : "";
    String rulesetUri = setDescription.getBindURI() != null ? setDescription.getBindURI() : "";
    boolean isInlined = (key == null || "".equals(key));
    String inlinedScript = setDescription.getRuleSource() != null ?
            setDescription.getRuleSource().toString() : "";
    String policyID = SequenceEditorHelper.getEditingMediatorPosition(session) + "_rulescript";
    Map ruleSourceMap = (Map) request.getSession().getAttribute("rulemediator_script_map");
    if (ruleSourceMap == null) {
        ruleSourceMap = new HashMap();
        request.getSession().setAttribute("rulemediator_script_map", ruleSourceMap);
    }
    ruleSourceMap.put(policyID, inlinedScript);

    Collection<PropertyDescription> creationProperties = setDescription.getCreationProperties();
    RuleMediatorClientHelper.registerNameSpaces(creationProperties, "creationpropertyValue", session);
//        Collection<PropertyDescription> registrationIterator = setDescription.getRegistrationProperties();
//        RuleMediatorClientHelper.registerNameSpaces(registrationIterator, "registrationpropertyValue", session);
//        Collection<PropertyDescription> deRegistrationIterator = setDescription.getDeregistrationProperties();
//        RuleMediatorClientHelper.registerNameSpaces(deRegistrationIterator, "deregistrationpropertyValue", session);

    //Session Metadata
    SessionDescription sessionDescription = configuration.getSessionDescription();
    if (sessionDescription == null) {
        sessionDescription = new SessionDescription();
    }
    Collection<PropertyDescription> sessionProperties = sessionDescription.getSessionProperties();
    RuleMediatorClientHelper.registerNameSpaces(sessionProperties, "rulesessionpropertyValue", session);

    //Inputs/outputs
    List<ResourceDescription> inputs = configuration.getFacts();
    List<ResourceDescription> outputs = configuration.getResults();

    String inputTableStyle = inputs.isEmpty() ? "display:none;" : "";
    String outputTableStyle = outputs.isEmpty() ? "display:none;" : "";
%>

<div>
<script type="text/javascript" src="../rule-mediator/js/mediator-util.js"></script>
<table class="normal" width="100%">
<tr>
    <td>
        <h2><fmt:message key="rule.mediator.header"/></h2>
    </td>
</tr>

<tr>
    <td><h3 class="mediator"><fmt:message key="mediator.rule.executionset"/></h3></td>
</tr>
<tr>
    <td>
        <table class="normal">
            <tr>
                <td><fmt:message key="mediator.rule.provider.uri"/>
                    <font style="color: red; font-size: 8pt;">*</font>
                </td>
                <td>
                    <input type="text" id="mediator.rule.executionset.uri"
                           name="mediator.rule.executionset.uri"
                           style="width:300px;" value='<%=rulesetUri != null ? rulesetUri : ""%>'/>
                </td>
            </tr>
        </table>
    </td>
</tr>
<tr>
    <td>
        <table class="normal">
            <tr>
                <td>
                    <select id="mediator.rule.inline"
                            name="mediator.rule.inline"
                            onchange="onScriptSourceModeSelectionChange();">
                        <%
                            if (isInlined) {
                        %>
                        <option id="inline" value="inline" selected="true"><fmt:message
                                key="in-lined"/></option>
                        </option>
                        <option id="registrykeylookup" value="registrykey">
                            <fmt:message key="registry.lookup"/>
                        </option>
                        <%
                        } else {
                        %>
                        <option id="registrykeylookup" value="registrykey"
                                selected="true"><fmt:message key="registry.lookup"/>
                        </option>
                        <option id="inline" value="inline"><fmt:message key="in-lined"/></option>
                        <%
                            }
                        %>
                    </select>
                </td>

                <td id="inline_rulescript" style="<%=!isInlined?"display:none" : ""%>">
                    <a
                            href="#ruleScriptBrowserLink" class="policie-icon-link"
                            style="padding-left:40px"
                            onclick="showInLinedRuleScriptPolicyEditor('<%=policyID%>');"><fmt:message
                            key="ruleScript.policy.editor"/></a>
                </td>

                <td id="regkey_rulescript" style="<%=isInlined? "display:none;" : ""%>">
                    <input type="text" class="longInput" id="mediator.rule.key"
                           name="mediator.rule.key" value="<%=key%>"
                           readonly="true"/>
                </td>
                <td id="regbrowser_rulescript"
                    style="<%=isInlined? "display:none;" : ""%>">
                    <a href="#registryBrowserLink" class="registry-picker-icon-link"
                       style="padding-left:20px;padding-left:20px"
                       onclick="showRegistryBrowser('mediator.rule.key','/_system/config');"><fmt:message
                            key="registry.conf.keys"/></a>
                    <a href="#registryBrowserLink" class="registry-picker-icon-link"
                       style="padding-left:20px"
                       onclick="showRegistryBrowser('mediator.rule.key','/_system/governance');"><fmt:message
                            key="registry.gov.keys"/></a>
                </td>
            </tr>
            <tr>
                <td>
                    <a name="ruleScriptBrowserLink"></a>

                    <div id="ruleScriptBrowser" style="display:none;"></div>
                </td>
            </tr>
        </table>
    </td>
</tr>
<%=RuleMediatorClientHelper.getPropertyXML("creation", creationProperties, request.getLocale())%>
    <%--<%=RuleMediatorClientHelper.getPropertyXML("registration", registrationIterator, request.getLocale())%>--%>
    <%--<%=RuleMediatorClientHelper.getPropertyXML("deregistration", deRegistrationIterator, request.getLocale())%>--%>
<tr>
    <td><h3 class="mediator"><fmt:message key="mediator.rule.rulesession"/></h3></td>
</tr>
<tr>
    <td>
        <table class="normal">
            <tr>
                <td><fmt:message key="mediator.rule.rulesession.type"/>
                </td>
                <td>
                    <select id="mediator.rule.session"
                            name="mediator.rule.session">
                        <%
                            if (sessionDescription.isStateful()) {
                        %>
                        <option value="<%=SessionDescription.STATEFUL_SESSION%>"
                                selected="selected">
                            <fmt:message key="stateful"/>
                        </option>
                        <option value="<%=SessionDescription.STATELESS_SESSION%>"><fmt:message
                                key="stateless"/></option>
                        <%
                        } else {
                        %>
                        <option value="<%=SessionDescription.STATELESS_SESSION%>"
                                selected="selected">
                            <fmt:message key="stateless"/>
                        </option>
                        <option value="<%=SessionDescription.STATEFUL_SESSION%>"><fmt:message
                                key="stateful"/></option>
                        <%
                            }
                        %>
                    </select>
                </td>
            </tr>
        </table>
    </td>
</tr>
<%=RuleMediatorClientHelper.getPropertyXML("rulesession", sessionProperties, request.getLocale())%>
<tr>
    <td><h3 class="mediator"><fmt:message key="mediator.rule.inputs"/></h3></td>
</tr>
<tr>
    <td>
        <table id="facttable" class="styledInner" style="<%=inputTableStyle%>;">
            <thead>
            <tr>
                <th width="10%"><fmt:message key="th.parameter.type"/></th>
                <th width="10%"><fmt:message key="th.fact.selector"/></th>
                <th width="10%"><fmt:message key="th.parameter.name"/></th>
                <th width="10%"><fmt:message key="th.fact.source.type"/></th>
                <th width="10%"><fmt:message key="th.value"/></th>
                <th id="reg-browser-th"><fmt:message key="registry.browser"/></th>
                <th id="ns-edior-th"><fmt:message key="namespaceeditor"/></th>
                <th><fmt:message key="th.action"/></th>
            </tr>
            <tbody id="facttbody">
            <%
                int k = 0;
                for (ResourceDescription fact : inputs) {
                    if (fact != null) {
                        String factType = fact.getType();
                        String sourceValue = (String) fact.getValue();
                        BaseXPath expression = fact.getExpression();
                        String regKey = fact.getKey();
                        boolean isKey = (regKey != null && !"".equals(regKey.trim()));
                        boolean isExpression = (expression != null);
                        String name = fact.getName();
                        if (name == null) {
                            name = "";
                        }
                        String factValue = "";
                        if (isKey) {
                            factValue = key;
                        } else if (isExpression) {
                            nameSpacesRegistrar.registerNameSpaces((AXIOMXPath) expression,
                                    "factValue" + k, session);
                            factValue = expression.toString();
                        } else {
                            factValue = sourceValue;
                        }
                        if (factValue == null) {
                            factValue = "";
                        }
            %>
            <tr id="factRaw<%=k%>">
                <td>
                    <input name="factType<%=k%>"
                           id="factType<%=k%>" value="<%=factType%>"
                           type="text"/>
                </td>
                <td><a class="fact-selector-icon-link" href="#factEditorLink"
                       style="padding-left:40px"
                       onclick="showFactEditor('fact','<%=k%>')"><fmt:message
                        key="fact.type"/></a></td>

                <td>
                    <input id="factName<%=k%>" name="factName<%=k%>"
                           type="text" value="<%=name%>"/>
                </td>
                <td>
                    <select name="factTypeSelection<%=k%>"
                            id="factTypeSelection<%=k%>"
                            onchange="onFactTypeSelectionChange('fact','<%=k%>')">
                        <% if (isKey) {%>
                        <option value="key" selected="selected">
                            <fmt:message key="key"/>
                        </option>
                        <option value="literal">
                            <fmt:message key="literal"/>
                        </option>
                        <option value="expression">
                            <fmt:message key="expression"/>
                        </option>
                        <%} else if (isExpression) { %>
                        <option value="expression" selected="selected">
                            <fmt:message key="expression"/>
                        </option>
                        <option value="literal">
                            <fmt:message key="literal"/>
                        </option>
                        <option value="key">
                            <fmt:message key="key"/>
                        </option>
                        <% } else {%>
                        <option value="literal" selected="selected">
                            <fmt:message key="literal"/>
                        </option>
                        <option value="key">
                            <fmt:message key="key"/>
                        </option>
                        <option value="expression">
                            <fmt:message key="expression"/>
                        </option>
                        <%}%>
                    </select>
                </td>
                <td>
                    <input id="factValue<%=k%>" name="factValue<%=k%>"
                           type="text" value="<%=factValue%>"/>
                </td>
                <td id="factRegistryBrowserButtonTD<%=k%>">
                    <a href="#registryBrowserLink"
                       class="registry-picker-icon-link"
                       onclick="showRegistryBrowser('factValue<%=k%>','/_system/config')">
                            <fmt:message
                                    key="registry.conf.keys"/>
                        <a href="#registryBrowserLink"
                           class="registry-picker-icon-link"
                           onclick="showRegistryBrowser('factValue<%=k%>','/_system/governance')"><fmt:message
                                key="registry.gov.keys"/>
                </td>
                <td id="factNsEditorButtonTD<%=k%>">
                    <a href="#nsEditorLink" class="nseditor-icon-link"
                       style="padding-left:40px"
                       onclick="showNameSpaceEditor('factValue<%=k%>')"><fmt:message
                            key="namespaces"/></a>
                </td>

                <td><a href="#" href="#" class="delete-icon-link" style="padding-left:40px"
                       onclick="deleteFact('fact','<%=k%>')"><fmt:message
                        key="delete"/></a></td>
            </tr>
            <% }
                k++;
            } %>
            <input type="hidden" name="factCount" id="factCount"
                   value="<%=k%>"/>
            </tbody>
        </table>
    </td>
</tr>
<tr>
    <td>
        <div style="margin-top:0px;">
            <a name="addfactLink"></a>
            <a class="add-icon-link"
               href="#addfactLink"
               onclick="addFact('fact')">
                <fmt:message key="add.fact"/></a>
        </div>
    </td>
</tr>
<tr>
    <td><h3 class="mediator"><fmt:message key="mediator.rule.outputs"/></h3></td>
</tr>
<tr>
    <td>
        <table id="resulttable" class="styledInner" style="<%=outputTableStyle%>;">
            <thead>
            <tr>
                <th width="10%"><fmt:message key="th.parameter.type"/></th>
                <th width="10%"><fmt:message key="th.result.selector"/></th>
                <th width="10%"><fmt:message key="th.parameter.name"/></th>
                <th width="10%"><fmt:message key="th.result.target.type"/></th>
                <th width="10%"><fmt:message key="th.value"/></th>
                <th id="resultreg-browser-th"><fmt:message key="registry.browser"/></th>
                <th id="resultns-edior-th"><fmt:message key="namespaceeditor"/></th>
                <th><fmt:message key="th.action"/></th>
            </tr>
            <tbody id="resulttbody">
            <%
                int j = 0;
                for (ResourceDescription result : outputs) {
                    if (result != null) {
                        String resultType = result.getType();
                        String sourceValue = (String) result.getValue();
                        BaseXPath expression = result.getExpression();
                        String regKey = result.getKey();
                        boolean isKey = (regKey != null && !"".equals(regKey.trim()));
                        boolean isExpression = (expression != null);
                        String name = result.getName();
                        if (name == null) {
                            name = "";
                        }
                        String resultValue = "";
                        if (isKey) {
                            resultValue = key;
                        } else if (isExpression) {
                            nameSpacesRegistrar.registerNameSpaces((AXIOMXPath) expression,
                                    "resultValue" + j, session);
                            resultValue = expression.toString();
                        } else {
                            resultValue = sourceValue;
                        }
                        if (resultValue == null) {
                            resultValue = "";
                        }
            %>
            <tr id="resultRaw<%=j%>">
                <td>
                    <input name="resultType<%=j%>"
                           id="resultType<%=j%>" value="<%=resultType%>"
                           type="text"/>
                </td>
                <td><a class="fact-selector-icon-link" href="#factEditorLink"
                       style="padding-left:40px"
                       onclick="showFactEditor('result','<%=j%>')"><fmt:message
                        key="result.type"/></a></td>

                <td>
                    <input id="resultName<%=j%>" name="resultName<%=j%>"
                           type="text" value="<%=name%>"/>
                </td>
                <td>
                    <select name="resultTypeSelection<%=j%>"
                            id="resultTypeSelection<%=j%>"
                            onchange="onFactTypeSelectionChange('result','<%=j%>')">
                        <% if (isKey) {%>
                        <option value="key" selected="selected">
                            <fmt:message key="key"/>
                        </option>
                        <option value="literal">
                            <fmt:message key="literal"/>
                        </option>
                        <option value="expression">
                            <fmt:message key="expression"/>
                        </option>
                        <%} else if (isExpression) { %>
                        <option value="expression" selected="selected">
                            <fmt:message key="expression"/>
                        </option>
                        <option value="literal">
                            <fmt:message key="literal"/>
                        </option>
                        <option value="key">
                            <fmt:message key="key"/>
                        </option>
                        <% } else {%>
                        <option value="literal" selected="selected">
                            <fmt:message key="literal"/>
                        </option>
                        <option value="key">
                            <fmt:message key="key"/>
                        </option>
                        <option value="expression">
                            <fmt:message key="expression"/>
                        </option>
                        <%}%>
                    </select>
                </td>
                <td>
                    <input id="resultValue<%=j%>" name="resultValue<%=j%>"
                           type="text" value="<%=resultValue%>"/>
                </td>
                <td id="resultRegistryBrowserButtonTD<%=j%>">
                    <a href="#registryBrowserLink"
                       class="registry-picker-icon-link"
                       onclick="showRegistryBrowser('resultValue<%=j%>','/_system/config')">
                            <fmt:message
                                    key="registry.conf.keys"/>
                        <a href="#registryBrowserLink"
                           class="registry-picker-icon-link"
                           onclick="showRegistryBrowser('resultValue<%=j%>','/_system/governance')"><fmt:message
                                key="registry.gov.keys"/>
                </td>
                <td id="resultNsEditorButtonTD<%=j%>">
                    <a href="#nsEditorLink" class="nseditor-icon-link"
                       style="padding-left:40px"
                       onclick="showNameSpaceEditor('resultValue<%=j%>')"><fmt:message
                            key="namespaces"/></a>
                </td>

                <td><a href="#" href="#" class="delete-icon-link" style="padding-left:40px"
                       onclick="deleteFact('result','<%=j%>')"><fmt:message
                        key="delete"/></a></td>
            </tr>
            <% }
                j++;
            } %>
            <input type="hidden" name="resultCount" id="resultCount"
                   value="<%=j%>"/>
            </tbody>
        </table>
    </td>
</tr>
<tr>
    <td>
        <div style="margin-top:0px;">
            <a name="addresultLink"></a>
            <a class="add-icon-link"
               href="#addresultLink"
               onclick="addFact('result')">
                <fmt:message key="add.result"/></a>
        </div>
    </td>
</tr>
</table>

<a name="nsEditorLink"></a>

<div id="nsEditor" style="display:none;"></div>

<a name="factEditorLink"></a>

<div id="factEditor" style="display:none;"></div>

<a name="registryBrowserLink"></a>

<div id="registryBrowser" style="display:none;"></div>
</div>
</fmt:bundle>
