<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1" %>
<%--
  ~  Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  Licensed under the Apache License, Version 2.0 (the "License");
  ~  you may not use this file except in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~        http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing, software
  ~  distributed under the License is distributed on an "AS IS" BASIS,
  ~  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~  See the License for the specific language governing permissions and
  ~  limitations under the License.
  --%>


<%@ page import="org.apache.axiom.om.OMElement" %>
<%@ page import="org.apache.axiom.om.impl.llom.util.AXIOMUtil" %>
<%@ page import="org.wso2.carbon.mediator.rule.RuleMediator" %>
<%@ page import="org.wso2.carbon.mediator.rule.ui.internal.RuleMediatorClientHelper" %>
<%@ page import="org.wso2.carbon.mediator.service.ui.Mediator" %>
<%@ page import="org.wso2.carbon.rulecep.commons.descriptions.rule.RuleSetDescription" %>
<%@ page import="org.wso2.carbon.rulecep.commons.descriptions.rule.SessionDescription" %>
<%@ page import="org.wso2.carbon.rulecep.commons.descriptions.rule.mediator.RuleMediatorDescription" %>
<%@ page import="org.wso2.carbon.sequences.ui.util.SequenceEditorHelper" %>
<%@ page import="java.util.Map" %>

<%
    try {
        Mediator mediator = SequenceEditorHelper.getEditingMediator(request, session);

        if (!(mediator instanceof RuleMediator)) {
            // todo : proper error handling
            throw new RuntimeException("Unable to edit the mediator");
        }

        RuleMediator ruleMediator = (RuleMediator) mediator;

        RuleMediatorDescription configuration = new RuleMediatorDescription();
        ruleMediator.setRuleMediatorDescription(configuration);

//      Creates RuleSet
        RuleSetDescription setDescription = new RuleSetDescription();
        configuration.setRuleSetDescription(setDescription);
        boolean isInlined = "inline".equals(request.getParameter("mediator.rule.inline"));
        if (isInlined) {
            String policyID = SequenceEditorHelper.getEditingMediatorPosition(session) + "_rulescript";
            Map policyXMLMap = (Map) request.getSession().getAttribute("rulemediator_script_map");
            if (policyXMLMap != null) {
                String policyXML = (String) policyXMLMap.get(policyID);
                if (policyXML != null && !"".equals(policyXML)) {
                    try {
                        OMElement ele = AXIOMUtil.stringToOM(policyXML);
                        setDescription.setRuleSource(ele);
                    } catch (Exception e) {
                    }
                }
            }
        } else {
            String key = request.getParameter("mediator.rule.key");
            if (key != null && !"".equals(key)) {
                setDescription.setKey(key.trim());
            }
        }
        String bindURI = request.getParameter("mediator.rule.executionset.uri");
        if (bindURI != null && !"".equals(bindURI)) {
            setDescription.setBindURI(bindURI.trim());
        }
        RuleMediatorClientHelper.setProperty(request, setDescription,
                "addCreationProperty", "creation");
//        RuleMediatorClientHelper.setProperty(request, session, setDescription,
//                "addRegistrationProperty", "registration");
//        RuleMediatorClientHelper.setProperty(request, session, setDescription,
//                "addDeregistrationProperty", "deregistration");

//        Creates Session
        SessionDescription sessionDescription = new SessionDescription();
        String ruleSession = request.getParameter("mediator.rule.session");
        if (ruleSession != null && !"".equals(ruleSession)) {
            sessionDescription.setSessionType(ruleSession.trim());
        }
        configuration.setSessionDescription(sessionDescription);
        RuleMediatorClientHelper.setProperty(request, sessionDescription,
                "addSessionPropertyDescription", "rulesession");
        RuleMediatorClientHelper.setFactsAndResults(request, configuration, "fact");
        RuleMediatorClientHelper.setFactsAndResults(request, configuration, "result");
%>


<%
} catch (Exception e) {

%>
<script type="text/javascript">
    jQuery(document).ready(function() {
        CARBON.showErrorDialog("An error has been occurred !. Error Message : " + '<%=e.getMessage()%>');
    });
</script>
<%
        return;
    }
%>
